//===============================//
// Copyright
// Klett-Autor S. Krivsky-Velten
// 2006
//===============================//

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;

public class KreisProz extends Applet {
//===============================//

 mitte Feld;
 oben Kontrolle;
 int MengenAnz = 4;
 int maxWinkel = 6;

 int[] KreisPkte = {10, 100, 180, 270}; // Lage des Punktes auf 360 Grad Kreisborgen
 //int[] KreisPkte = {10, 100, 180, 200, 270, 300, 330};

 int[] Winkel = new int[MengenAnz]; 	// Winkelgroesse zwischen der Winkel
 int[] WinkelDez = new int[MengenAnz];	// Winkelgroessen am Lineal
 										// Farben der Winkel
 Color[] Farbwahl = {Color.blue.darker(), Color.green.darker(), Color.orange, Color.red.darker()};
 //Color[] Farbwahl = {Color.blue.darker(), Color.green.darker(), Color.red.darker(), Color.green, Color.orange, Color.cyan.darker(), Color.magenta.darker()};
 int[] LinealBruchPos = new int[MengenAnz]; 	// Position des Bruches oberhalb des Lineals

 int aktiv = -1;

 int diam = 240;						// Durchmesser des Kreises
 int rad = diam/2;						// Radius des Kreises
 int laenge = 600;						// Breite des Rechtecks
 int hoehe = (int)(Math.round(Math.PI * rad*rad / laenge));		// Hoehe des Rechtecks
 int balken = diam;						// Hoehe des Koordinatensystems

 int Punktd = 10;						// Durchmesser der Punkte
 int Balkenb = 40;						// Breite der Balken
 int Balkend = 20;						// Abstaende zwischen Balken

 int xm = 170;							// Kreismittelpunkt
 int ym = 170;							// Kreismittelpunkt
 int xa = xm-rad;						// Rechteckanfang
 int ya = ym+rad+60;					// Rechteckanfang
 int xk = xa+laenge-MengenAnz*(Balkenb+Balkend)-Balkend;;						// Koordinatenursprung
 int yk = ym+rad;						// Koordinatenursprung

 int Buchh = 14;		// Hoehe der Schrift

 Font SchriftArt=new Font("Helvetica",Font.BOLD,16);
 //Font SchriftArtklein=new Font("Helvetica",Font.PLAIN,Buchh);
 Font SchriftArtklein=new Font("Helvetica",Font.BOLD,Buchh);

 int Bruchbreite = Buchh;
 boolean fertig = false;


 public void init() {
   setBackground(Color.white);
   setLayout(new BorderLayout());

   add("Center", Feld = new mitte(this));
   add("North",  Kontrolle  = new oben(this));

   for (int i=0; i<(MengenAnz-1); i++) {
	   Winkel[i] = KreisPkte[i+1]-KreisPkte[i];
   }
   Winkel[MengenAnz-1] = 360+KreisPkte[MengenAnz-1]-KreisPkte[0];
 } // init



 public void start() {
   Feld.init();
   Feld.faerbe();

 }



//////////////////////
// Das Feld         //
//////////////////////

 class mitte extends Panel {

		boolean neu=true;				// Kontrolliert obein Punkt neu ANGEKLICKT wird
  KreisProz theapplet;
  Image img;
  Graphics imggc;
  int width,height;
  int[] PunktePx = new int[MengenAnz];   // Position des Punktes auf Feld
  int[] PunktePy = new int[MengenAnz];   // Position des Punktes auf Feld
  float winkel=((float)(2*Math.PI))/360;


  public mitte(KreisProz a) {
	  theapplet = a;
	  addMouseListener( new meinMA());
	  addMouseMotionListener( new meinMML());

  }


   public void init() {
      if (img==null) {
    	  // Anfangsbild erstellen
    	  // Uebernehme die Groessen-Daten von Aufruf
    	  //  und erzeuge Bild in entsprechender Groesse
    	  Dimension d=size();
    	  width=d.width; height=d.height;    // Breite&Hoehe des Bildes
    	  img=createImage(width,height);
    	  imggc=img.getGraphics();
    	  img=createImage(width,height);
    	  imggc=img.getGraphics();
     	  imggc.setFont(SchriftArtklein);
    	  FontMetrics fm = getFontMetrics(SchriftArtklein);
    	  Bruchbreite = fm.stringWidth("360");
    	  PunktePx[0] = xm + rad;
    	  PunktePy[0] = ym;
    	  for (int i=0; i<MengenAnz; i++) {
    		  PunktePx[i] = xm+(int)(Math.round(Math.cos(KreisPkte[i]*winkel)*rad));
    		  PunktePy[i] = ym-(int)(Math.round(Math.sin(KreisPkte[i]*winkel)*rad));
    		  imggc.fillArc(PunktePx[i]-Punktd/2, PunktePy[i]-Punktd/2, Punktd, Punktd, 360, 360);
    	  }
    	  validate();
       }
    }


   public void paint(Graphics gc) {
      if (img!=null) gc.drawImage(img,0,0,theapplet);
   }

   public void update(Graphics gc) {
      if (img!=null) gc.drawImage(img,0,0,theapplet);
   }



   void Bruchmalen (int Z, int N, int px, int py) {
	   imggc.setFont(SchriftArtklein);
	   FontMetrics fm = getFontMetrics(SchriftArtklein);
	   px = px-2;
	   py = py-3;

	   int ZB = fm.stringWidth(""+Math.abs(Z));
	   int SB = Bruchbreite;
	   if (Bruchbreite < ZB) {
		   SB = ZB;
	   }
	   imggc.drawString( ""+Z, px-(ZB/2)+2, py-Buchh );
	   imggc.drawLine(px-(SB/2)-1, py-Buchh+1, px+(SB/2)+3, py-Buchh+1 );
	   imggc.drawString( ""+N, px-(Bruchbreite/2)+2, py );
	   repaint();
	}


  void Kreismalen() {
	  // Kreissegmente und Brche zeichnen
	   imggc.setFont(SchriftArtklein);
	   FontMetrics fm = getFontMetrics(SchriftArtklein);
	  for (int i=0; i<MengenAnz; i++) {
		  imggc.setColor(Farbwahl[i]);
		  imggc.fillArc(xm-rad, ym-rad, diam, diam, KreisPkte[i], Winkel[i]);
		  Bruchmalen (Winkel[i], 360, xm-rad+i*diam/MengenAnz+fm.stringWidth("360"), ym-rad-20);
	  }
	  // Kreisrand zeichnen
	  imggc.setColor(Color.darkGray);
	  imggc.drawArc(xm-rad, ym-rad, diam, diam, 0, 360);
	  // Punkte auf Kreis zeichnen
	  imggc.setColor(Color.darkGray);
	  for (int i=0; i<MengenAnz; i++) {
		  PunktePx[i] = xm+(int)(Math.round(Math.cos(KreisPkte[i]*winkel)*rad));
		  PunktePy[i] = ym-(int)(Math.round(Math.sin(KreisPkte[i]*winkel)*rad));
		  imggc.fillArc(PunktePx[i]-Punktd/2, PunktePy[i]-Punktd/2, Punktd, Punktd, 360, 360);
	  }
  }

  void Rechteckmalen() {
	  // Rechtecksegmente und Brche zeichnen
	  int RechteckP = xa+1;
	  for (int i=MengenAnz-1; 0<=i; i--) {

	  }
	  for (int i=0; i<MengenAnz; i++) {
		  imggc.setColor(Farbwahl[i]);
		  imggc.fillRect(RechteckP, ya, (laenge*WinkelDez[i])/100, hoehe);
		  LinealBruchPos[i] = RechteckP+(laenge*WinkelDez[i])/200;
		  if (i>0) {
			  if ( (LinealBruchPos[i]-LinealBruchPos[i-1]) < Bruchbreite ) {
				  LinealBruchPos[i] = LinealBruchPos[i-1]+Bruchbreite+2;
			  }
		  }
		  Bruchmalen (WinkelDez[i], 100, LinealBruchPos[i], ya-2);
		  RechteckP = RechteckP+(laenge*WinkelDez[i])/100;
	  }
	  // Kreisrand zeichnen
	  imggc.setColor(Color.darkGray);
	  for (int i=1; i<100; i=i+1) {
		  imggc.drawLine(xa+(laenge*i)/100, ya, xa+(laenge*i)/100, ya+10);
	  }
	  imggc.setColor(Color.black);
	  for (int i=10; i<100; i=i+10) {
		  imggc.drawLine(xa+(laenge*i)/100, ya, xa+(laenge*i)/100, ya+20);
	  }
	  imggc.drawRect( xa, ya, laenge, hoehe);
  }

  void Balkenmalen() {
	  imggc.setFont(SchriftArtklein);
	  FontMetrics fm = getFontMetrics(SchriftArtklein);

	  imggc.setColor(Color.lightGray);
	  int bbreit = (MengenAnz)*(Balkenb+Balkend)+Balkend;
	  for (int i=1; i<100; i=i+10) {
		  imggc.drawLine(xk, yk-(balken*i)/100, xk+bbreit, yk-(balken*i)/100);
	  }
	  // Balkensegmente und Brche zeichnen
	  for (int i=0; i<MengenAnz; i++) {
		  imggc.setColor(Farbwahl[i]);
		  imggc.fillRect(xk+i*(Balkenb+Balkend)+Balkend, yk-(balken*WinkelDez[i])/100, Balkenb, (balken*WinkelDez[i])/100);
		  String PT = ""+WinkelDez[i]+"%";
		  int TB = fm.stringWidth(PT);
		  imggc.drawString (PT, xk+Balkend+i*(Balkenb+Balkend)+(Balkenb-TB)/2, yk-(balken*WinkelDez[i])/100-2);
	  }
	  // Koordinatensyst zeichnen
	  imggc.setColor(Color.darkGray);
	  imggc.drawRect(xk, yk-balken, bbreit, balken);


  }

  void faerbe() {
  int merk;
	  imggc.setColor (Color.WHITE);
	  imggc.fillRect(0,0,width,height);
	  int sum=0;
	  for (int i=0; i<MengenAnz; i++) {
		  Winkel[i] = (360+KreisPkte[(i+1)%MengenAnz]-KreisPkte[i])%360;
		  WinkelDez[i] = (int)Math.round((double)(Winkel[i])*10/36);
//		  System.out.println(""+Winkel[i]+"/360 = "+((double)(Winkel[i])*10/36)+"/100 = "+WinkelDez[i]);
		  sum=sum+WinkelDez[i];

	  }
	  while (sum > 100) {
		  merk = 0;
		  for (int i=1; i<MengenAnz; i++) {
			if ( Math.abs((double)(Winkel[merk])*10/36 - (WinkelDez[merk]-1)) >= Math.abs((double)(Winkel[i])*10/36 - (WinkelDez[i]-1)) ) {
				merk = i;
		  	}
		  }
//		  System.out.print( "reduziere "+merk);
		  WinkelDez[merk]=WinkelDez[merk]-1;
		  sum=sum-1;
//		  System.out.println(" => Wegen "+WinkelDez[merk]+" nun Summe "+sum);
	  }
	  while (sum < 100) {
		  merk = 0;
		  for (int i=1; i<MengenAnz; i++) {
			  if ( Math.abs((double)(Winkel[merk])*10/36 - (WinkelDez[merk]+1)) >= Math.abs((double)(Winkel[i])*10/36 - (WinkelDez[i]+1)) ) {
				  merk = i;
		  	}
		  }
//		  System.out.print( "erhoehe "+merk);
		  WinkelDez[merk] = WinkelDez[merk]+1;
		  sum++;
//		  System.out.println(" => Wegen "+WinkelDez[merk]+" nun Summe "+sum);

	  }

	  Kreismalen();
	  Rechteckmalen();
	  Balkenmalen();


	  repaint();
  } // void faerbe



//===================
//Maus-Reaktionen
//===================


	class meinMML extends MouseMotionAdapter {


		public void mouseDragged(MouseEvent me) {
				int mx = me.getX();
				int my = me.getY();

				// Test ob auf einen Punkt am Kreis geklickt wurde
				if ((aktiv == -1) && (neu)
						&& (xm - rad - Punktd <= mx)
						&& (mx <= xm + rad + Punktd)
						&& (ym - rad - Punktd <= my)
						&& (ym <= ym + rad + Punktd)) {
					// Test welcher Punkt getroffen wird
					for (int i = 0; i < MengenAnz; i++) {
						if ((PunktePx[i] - Punktd <= mx)
								&& (mx <= PunktePx[i] + Punktd)
								&& (PunktePy[i] - Punktd <= my)
								&& (my <= PunktePy[i] + Punktd)) {
							aktiv = i;
							neu = false;
						}
					}
				}

				// Falls Punkt angeklickt ist
				if (aktiv > -1) {

					// Winkel bestimmen
					int Zaehler = 0;
					if (mx >= xm) {
						if (my <= ym) {
							Zaehler = (int)(Math.round(-180
									* Math.atan((double) (my - ym) / (mx - xm)) / Math.PI));
						} else {
							Zaehler = (int)(Math.round(360 - 180
									* Math.atan((double) (my - ym) / (mx - xm))
									/ Math.PI));
						}
					} else {
						Zaehler = (int)(Math.round(180 + -180
								* Math.atan((double) (my - ym) / (mx - xm))
								/ Math.PI));
					}
					int Rest = Zaehler % 360;
					int winkelrest = Math.round(Rest);

					// Test ob Nachbarpunkte getroffen werden
					// Reihenfolge: KreisPkte[vor] < winkelrest < KreisPkte[nach]

					boolean testnach = true;
					boolean testvor = true;
					int nach = (MengenAnz+aktiv+1)%MengenAnz;
					int vor = (MengenAnz+aktiv-1)%MengenAnz;

					if ( (KreisPkte[nach]-KreisPkte[vor]) > 0 ) {
						// Intervall enthlt nicht die Null
						if (winkelrest <= KreisPkte[vor]+maxWinkel) {
							testvor = false;
						}
						if (KreisPkte[nach]-maxWinkel <= winkelrest) {
							testnach = false;
						}
					}
					else {
						// Intervall entht die Null
						if ( (winkelrest-KreisPkte[vor]) > 0 ){
							if ( KreisPkte[vor]+maxWinkel >= winkelrest ) {
							// nicht: 0 < P[vor] < winkel < P[aktiv] < 360
							// also : P[vor] > winkel
								testvor = false;
							}
						}
						else {
							//if ( (KreisPkte[(MengenAnz+vor-1)%MengenAnz] <= winkelrest) && (winkelrest <= KreisPkte[vor]) ) {
							if ( (KreisPkte[nach]-maxWinkel <= winkelrest) && (winkelrest <= KreisPkte[vor]+maxWinkel) ) {
							// nicht: P[vor-1] < winkel < P[vor] < 360=0 < P[aktiv]
							// also : P[vor-1] <= winkel <= P[vor]
								testvor = false;
							}
						}

						if ( (KreisPkte[nach]-winkelrest) > 0 ){
							if ( winkelrest >= KreisPkte[nach] ) {
								testnach = false;
							}
						}
						else {
							//if ( (KreisPkte[nach] <= winkelrest) && (winkelrest <= KreisPkte[(MengenAnz+nach+1)%MengenAnz]) ) {
							if ( (KreisPkte[nach] <= winkelrest) && (winkelrest <= KreisPkte[vor]) ) {
								testnach = false;
							}
						}
					}


//					System.out.println(" ");
					if (testvor && testnach) {

						KreisPkte[aktiv] = winkelrest;
						PunktePx[aktiv] = xm
								+ (int) (Math.round(Math.cos(winkelrest
										* winkel)
										* rad));
						PunktePy[aktiv] = ym
								+ (int) (Math.round(Math.sin(winkelrest
										* winkel)
										* rad));
						Winkel[(MengenAnz+aktiv-1)%MengenAnz] = KreisPkte[aktiv] - KreisPkte[(MengenAnz+aktiv-1)%MengenAnz];
						Winkel[aktiv] = KreisPkte[(aktiv+1)%MengenAnz] - KreisPkte[aktiv];
					}
					else {
						aktiv = -1;
					}
				}
				faerbe();
			} // Ende MouseDragged

	} // Ende meinMML


	class meinMA extends MouseAdapter {

		public void mouseReleased( MouseEvent me ) {
			aktiv = -1;
			neu = true;
		} // Ende mouseReleased


	} // Ende meinMA



} // Mitte



////////////////////////////////////////////////////////////
//         Die oberen Einstellungen                       //
////////////////////////////////////////////////////////////

	class oben extends Panel {
	KreisProz theapplet;

	Button Knopf = new Button("Ausgangsposition");

	public oben (KreisProz a) {
		theapplet = a;
		//setLayout(new FlowLayout());
		setLayout(new BorderLayout());
		setFont(new Font("Helvetica",Font.PLAIN,14));
		Knopf.setBackground(Color.lightGray);
		Knopf.setFont(SchriftArt);

		ActionListener ActionButton = new ActionListener() {
			public void actionPerformed(ActionEvent e){
				KreisPkte[0] = 10;
				KreisPkte[1] = 100;
				KreisPkte[2] = 180;
				KreisPkte[3] = 270;
				for (int i=0; i<(MengenAnz-1); i++) {
					Winkel[i] = KreisPkte[i+1]-KreisPkte[i];
				}
				Winkel[MengenAnz-1] = 360+KreisPkte[MengenAnz-1]-KreisPkte[0];
				Feld.faerbe();
			}
		};
		Knopf.addActionListener(ActionButton);
		add("East", Knopf);
	} // public oben

 	} // class oben

} // class KreisProz
